TableDisplay (base API)
Date: 2019-04-05

com.twosigma.beakerx.table

## Class TableDisplay

- java.lang.Object
- - com.twosigma.beakerx.widget.Widget
  - - com.twosigma.beakerx.widget.BeakerxWidget
    - - com.twosigma.beakerx.table.TableDisplay

- All Implemented Interfaces:
    com.twosigma.beakerx.widget.CommFunctionality, com.twosigma.beakerx.widget.DisplayableWidget, com.twosigma.beakerx.widget.WidgetItem

      public class TableDisplay
      extends com.twosigma.beakerx.widget.BeakerxWidget

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `TableDisplay.Element`

    - ### Nested classes/interfaces inherited from class com.twosigma.beakerx.widget.Widget

      `com.twosigma.beakerx.widget.Widget.ActionPerformed, com.twosigma.beakerx.widget.Widget.WidgetDisplayMethodStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `DICTIONARY_SUBTYPE`
    `static java.lang.String` | `LIST_OF_MAPS_SUBTYPE`
    `static java.lang.String` | `MATRIX_SUBTYPE`
    `static java.lang.String` | `MODEL_NAME_VALUE`
    `int` | `ROW_LIMIT_TO_INDEX`
    `int` | `ROWS_LIMIT`
    `static java.lang.String` | `TABLE_DISPLAY_SUBTYPE`
    `static java.lang.String` | `VIEW_NAME_VALUE`

    - ### Fields inherited from class com.twosigma.beakerx.widget.BeakerxWidget

      `MODEL, MODEL_MODULE_VALUE, MODEL_UPDATE, VIEW_MODULE_VALUE`

    - ### Fields inherited from class com.twosigma.beakerx.widget.Widget

      `APPLICATION_VND_JUPYTER_WIDGET_VIEW_JSON, DESCRIPTION, DISABLED, DISPLAY, INDEX, METHOD, MODEL_ID, MODEL_MODULE, MODEL_MODULE_VERSION, MODEL_MODULE_VERSION_VALUE, MODEL_NAME, MSG_THROTTLE, VALUE, VIEW_MODULE, VIEW_MODULE_VERSION, VIEW_MODULE_VERSION_VALUE, VIEW_NAME, VISIBLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TableDisplay(java.util.Collection<java.util.Map<java.lang.String,java.lang.Object>> v)`
    `TableDisplay(java.util.Collection<java.util.Map<java.lang.String,java.lang.Object>> v, com.twosigma.beakerx.jvm.serialization.BeakerObjectConverter serializer)`
    `TableDisplay(int rowCount, int columnCount, java.util.List<java.lang.String> columnNames, TableDisplay.Element element)`
    `TableDisplay(java.util.List<java.util.List<?>> v, java.util.List<java.lang.String> co, java.util.List<java.lang.String> cl)`
    `TableDisplay(java.util.Map<?,?> v)`
    `TableDisplay(java.util.Map<java.lang.String,java.lang.Object>[] v)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCellHighlighter(CellHighlighter cellHighlighter)`
    `void` | `addCellHighlighter(java.lang.Object closure)`
    `void` | `addCellHighlighter(TableDisplayCellHighlighter cellHighlighter)`
    `void` | `addContextMenuItem(java.lang.String name, java.lang.Object closure)`
    `void` | `addContextMenuItem(java.lang.String name, java.lang.String tagName)`
    `static TableDisplay` | `createTableDisplayForMap(java.util.Map<?,?> v)`
    `void` | `fireContextMenuClick(java.lang.String name, java.util.List<java.lang.Object> params, com.twosigma.beakerx.message.Message message)`
    `void` | `fireDoubleClick(java.util.List<java.lang.Object> params, com.twosigma.beakerx.message.Message message)`
    `java.util.Map<java.lang.String,TableDisplayAlignmentProvider>` | `getAlignmentForColumn()`
    `java.util.Map<ColumnType,TableDisplayAlignmentProvider>` | `getAlignmentForType()`
    `java.util.List<TableDisplayCellHighlighter>` | `getCellHighlighters()`
    `java.util.List<java.lang.String>` | `getColumnNames()`
    `java.util.List<java.lang.String>` | `getColumnOrder()`
    `java.util.Map<java.lang.String,java.lang.Boolean>` | `getColumnsFrozen()`
    `java.util.Map<java.lang.String,java.lang.Boolean>` | `getColumnsFrozenRight()`
    `java.util.Map<java.lang.String,java.lang.Boolean>` | `getColumnsVisible()`
    `java.util.Set<java.lang.String>` | `getContextMenuItems()`
    `java.util.Map<java.lang.String,java.lang.String>` | `getContextMenuTags()`
    `java.lang.Integer` | `getDataFontSize()`
    `TableActionDetails` | `getDetails()`
    `java.lang.String` | `getDoubleClickTag()`
    `java.util.List<java.util.List<?>>` | `getFilteredValues()`
    `java.util.List<java.util.List<Color>>` | `getFontColor()`
    `java.lang.String` | `getHasIndex()`
    `java.lang.Integer` | `getHeaderFontSize()`
    `java.lang.Boolean` | `getHeadersVertical()`
    `java.lang.String` | `getModelNameValue()`
    `java.util.Map<java.lang.String,TableDisplayCellRenderer>` | `getRendererForColumn()`
    `java.util.Map<ColumnType,TableDisplayCellRenderer>` | `getRendererForType()`
    `java.lang.String` | `getRowLimitMsg()`
    `java.util.Map<java.lang.String,TableDisplayStringFormat>` | `getStringFormatForColumn()`
    `java.util.concurrent.TimeUnit` | `getStringFormatForTimes()`
    `java.util.Map<ColumnType,TableDisplayStringFormat>` | `getStringFormatForType()`
    `java.lang.String` | `getSubtype()`
    `java.lang.String` | `getTimeZone()`
    `java.util.List<java.util.List<java.lang.String>>` | `getTooltips()`
    `java.util.List<java.lang.String>` | `getTypes()`
    `java.util.List<java.util.List<?>>` | `getValues()`
    `java.util.Map<java.lang.String,java.lang.Object>` | `getValuesAsDictionary()`
    `static java.util.Map<java.lang.String,java.lang.Object>` | `getValuesAsDictionary(java.util.List<java.util.List<?>> values)`
    `java.util.List<java.util.List<?>>` | `getValuesAsMatrix()`
    `static java.util.List<java.util.List<?>>` | `getValuesAsMatrix(java.util.List<java.util.List<?>> values)`
    `java.util.List<java.util.Map<java.lang.String,java.lang.Object>>` | `getValuesAsRows()`
    `static java.util.List<java.util.Map<java.lang.String,java.lang.Object>>` | `getValuesAsRows(java.util.List<java.util.List<?>> values, java.util.List<java.lang.String> columns)`
    `java.lang.String` | `getViewNameValue()`
    `boolean` | `hasDoubleClickAction()`
    `protected void` | `openComm()`
    `void` | `removeAllCellHighlighters()`
    `protected java.lang.Object` | `runClosure(java.lang.Object closure, java.lang.Object... params)`
    `protected java.util.Map` | `serializeToJsonObject()`
    `protected java.util.Map` | `serializeToJsonObject(java.lang.Object item)`
    `void` | `setAlignmentProviderForColumn(java.lang.String column, TableDisplayAlignmentProvider alignmentProvider)`
    `void` | `setAlignmentProviderForType(ColumnType type, TableDisplayAlignmentProvider alignmentProvider)`
    `void` | `setColumnFrozen(java.lang.String column, boolean frozen)`
    `void` | `setColumnFrozenRight(java.lang.String column, boolean frozen)`
    `void` | `setColumnOrder(java.util.List<java.lang.String> columnOrder)`
    `void` | `setColumnVisible(java.lang.String column, boolean visible)`
    `void` | `setDataFontSize(java.lang.Integer dataFontSize)`
    `void` | `setDetails(TableActionDetails details)`
    `void` | `setDoubleClickAction(java.lang.Object listener)`
    `void` | `setDoubleClickAction(java.lang.String tagName)`
    `void` | `setFontColorProvider(FontColorProvider fontColorProvider)`
    `void` | `setFontColorProvider(java.lang.Object closure)`
    `void` | `setHasIndex(java.lang.String hasIndex)`
    `void` | `setHeaderFontSize(java.lang.Integer headerFontSize)`
    `void` | `setHeadersVertical(boolean headersVertical)`
    `void` | `setRendererForColumn(java.lang.String column, TableDisplayCellRenderer renderer)`
    `void` | `setRendererForType(ColumnType type, TableDisplayCellRenderer renderer)`
    `void` | `setRowFilter(java.lang.Object closure)`
    `void` | `setRowFilter(RowFilter rowFilter)`
    `void` | `setRowLimitMsg(java.lang.String rowLimitMsg)`
    `void` | `setStringFormatForColumn(java.lang.String column, java.lang.Object closure)`
    `void` | `setStringFormatForColumn(java.lang.String column, TableDisplayStringFormat format)`
    `void` | `setStringFormatForTimes(java.util.concurrent.TimeUnit stringFormatForTimes)`
    `void` | `setStringFormatForType(ColumnType type, TableDisplayStringFormat format)`
    `void` | `setTimeZone(java.lang.String timeZone)`
    `void` | `setToolTip(java.lang.Object closure)`
    `void` | `setTooltip(TooltipAction tooltip)`
    `void` | `updateCell(int row, java.lang.String columnName, java.lang.Object value)`

    - ### Methods inherited from class com.twosigma.beakerx.widget.BeakerxWidget

      `activateWidgetInContainer, addValueChangeMsgCallback, beforeDisplay, content, getModelModuleValue, getViewModuleValue, sendModel, sendModelUpdate, sendModelUpdate`

    - ### Methods inherited from class com.twosigma.beakerx.widget.Widget

      `asWidget, close, display, getComm, getModelModuleVersion, getViewModuleVersion, handleCommEventSync, openComm, sendDisplay, sendUpdate, sendUpdate, sendUpdate`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### VIEW_NAME_VALUE

          public static final java.lang.String VIEW_NAME_VALUE

      See Also:
        Constant Field Values

    - #### MODEL_NAME_VALUE

          public static final java.lang.String MODEL_NAME_VALUE

      See Also:
        Constant Field Values

    - #### TABLE_DISPLAY_SUBTYPE

          public static final java.lang.String TABLE_DISPLAY_SUBTYPE

      See Also:
        Constant Field Values

    - #### LIST_OF_MAPS_SUBTYPE

          public static final java.lang.String LIST_OF_MAPS_SUBTYPE

      See Also:
        Constant Field Values

    - #### MATRIX_SUBTYPE

          public static final java.lang.String MATRIX_SUBTYPE

      See Also:
        Constant Field Values

    - #### DICTIONARY_SUBTYPE

          public static final java.lang.String DICTIONARY_SUBTYPE

      See Also:
        Constant Field Values

    - #### ROWS_LIMIT

          public int ROWS_LIMIT

    - #### ROW_LIMIT_TO_INDEX

          public int ROW_LIMIT_TO_INDEX

  - ### Constructor Detail

    - #### TableDisplay

          public TableDisplay(java.util.List<java.util.List<?>> v,
                              java.util.List<java.lang.String> co,
                              java.util.List<java.lang.String> cl)

    - #### TableDisplay

          public TableDisplay(java.util.Collection<java.util.Map<java.lang.String,java.lang.Object>> v)

    - #### TableDisplay

          public TableDisplay(java.util.Map<java.lang.String,java.lang.Object>[] v)

    - #### TableDisplay

          public TableDisplay(java.util.Collection<java.util.Map<java.lang.String,java.lang.Object>> v,
                              com.twosigma.beakerx.jvm.serialization.BeakerObjectConverter serializer)

    - #### TableDisplay

          public TableDisplay(java.util.Map<?,?> v)

    - #### TableDisplay

          public TableDisplay(int rowCount,
                              int columnCount,
                              java.util.List<java.lang.String> columnNames,
                              TableDisplay.Element element)

  - ### Method Detail

    - #### getModelNameValue

          public java.lang.String getModelNameValue()

      Specified by:
        `getModelNameValue` in class `com.twosigma.beakerx.widget.Widget`

    - #### getViewNameValue

          public java.lang.String getViewNameValue()

      Specified by:
        `getViewNameValue` in class `com.twosigma.beakerx.widget.Widget`

    - #### createTableDisplayForMap

          public static TableDisplay createTableDisplayForMap(java.util.Map<?,?> v)

    - #### openComm

          protected void openComm()

      Overrides:
        `openComm` in class `com.twosigma.beakerx.widget.Widget`

    - #### getStringFormatForTimes

          public java.util.concurrent.TimeUnit getStringFormatForTimes()

    - #### setStringFormatForTimes

          public void setStringFormatForTimes(java.util.concurrent.TimeUnit stringFormatForTimes)

    - #### getStringFormatForType

          public java.util.Map<ColumnType,TableDisplayStringFormat> getStringFormatForType()

    - #### setStringFormatForType

          public void setStringFormatForType(ColumnType type,
                                             TableDisplayStringFormat format)

    - #### getStringFormatForColumn

          public java.util.Map<java.lang.String,TableDisplayStringFormat> getStringFormatForColumn()

    - #### setStringFormatForColumn

          public void setStringFormatForColumn(java.lang.String column,
                                               TableDisplayStringFormat format)

    - #### setStringFormatForColumn

          public void setStringFormatForColumn(java.lang.String column,
                                               java.lang.Object closure)

    - #### getRendererForType

          public java.util.Map<ColumnType,TableDisplayCellRenderer> getRendererForType()

    - #### setRendererForType

          public void setRendererForType(ColumnType type,
                                         TableDisplayCellRenderer renderer)

    - #### getRendererForColumn

          public java.util.Map<java.lang.String,TableDisplayCellRenderer> getRendererForColumn()

    - #### setRendererForColumn

          public void setRendererForColumn(java.lang.String column,
                                           TableDisplayCellRenderer renderer)

    - #### getAlignmentForType

          public java.util.Map<ColumnType,TableDisplayAlignmentProvider> getAlignmentForType()

    - #### setAlignmentProviderForType

          public void setAlignmentProviderForType(ColumnType type,
                                                  TableDisplayAlignmentProvider alignmentProvider)

    - #### getAlignmentForColumn

          public java.util.Map<java.lang.String,TableDisplayAlignmentProvider> getAlignmentForColumn()

    - #### setAlignmentProviderForColumn

          public void setAlignmentProviderForColumn(java.lang.String column,
                                                    TableDisplayAlignmentProvider alignmentProvider)

    - #### getColumnsFrozen

          public java.util.Map<java.lang.String,java.lang.Boolean> getColumnsFrozen()

    - #### setColumnFrozen

          public void setColumnFrozen(java.lang.String column,
                                      boolean frozen)

    - #### getColumnsFrozenRight

          public java.util.Map<java.lang.String,java.lang.Boolean> getColumnsFrozenRight()

    - #### setColumnFrozenRight

          public void setColumnFrozenRight(java.lang.String column,
                                           boolean frozen)

    - #### getColumnsVisible

          public java.util.Map<java.lang.String,java.lang.Boolean> getColumnsVisible()

    - #### setColumnVisible

          public void setColumnVisible(java.lang.String column,
                                       boolean visible)

    - #### getColumnOrder

          public java.util.List<java.lang.String> getColumnOrder()

    - #### getCellHighlighters

          public java.util.List<TableDisplayCellHighlighter> getCellHighlighters()

    - #### addCellHighlighter

          public void addCellHighlighter(TableDisplayCellHighlighter cellHighlighter)

    - #### addCellHighlighter

          public void addCellHighlighter(java.lang.Object closure)

    - #### addCellHighlighter

          public void addCellHighlighter(CellHighlighter cellHighlighter)

    - #### removeAllCellHighlighters

          public void removeAllCellHighlighters()

    - #### setColumnOrder

          public void setColumnOrder(java.util.List<java.lang.String> columnOrder)

    - #### setToolTip

          public void setToolTip(java.lang.Object closure)

    - #### setTooltip

          public void setTooltip(TooltipAction tooltip)

    - #### getTooltips

          public java.util.List<java.util.List<java.lang.String>> getTooltips()

    - #### getDataFontSize

          public java.lang.Integer getDataFontSize()

    - #### setDataFontSize

          public void setDataFontSize(java.lang.Integer dataFontSize)

    - #### getHeaderFontSize

          public java.lang.Integer getHeaderFontSize()

    - #### setHeaderFontSize

          public void setHeaderFontSize(java.lang.Integer headerFontSize)

    - #### getFontColor

          public java.util.List<java.util.List<Color>> getFontColor()

    - #### setFontColorProvider

          public void setFontColorProvider(java.lang.Object closure)

    - #### setFontColorProvider

          public void setFontColorProvider(FontColorProvider fontColorProvider)

    - #### setRowFilter

          public void setRowFilter(java.lang.Object closure)

    - #### setRowFilter

          public void setRowFilter(RowFilter rowFilter)

    - #### setHeadersVertical

          public void setHeadersVertical(boolean headersVertical)

    - #### getHeadersVertical

          public java.lang.Boolean getHeadersVertical()

    - #### setHasIndex

          public void setHasIndex(java.lang.String hasIndex)

    - #### getHasIndex

          public java.lang.String getHasIndex()

    - #### setTimeZone

          public void setTimeZone(java.lang.String timeZone)

    - #### getTimeZone

          public java.lang.String getTimeZone()

    - #### getFilteredValues

          public java.util.List<java.util.List<?>> getFilteredValues()

    - #### getValuesAsRows

          public static java.util.List<java.util.Map<java.lang.String,java.lang.Object>> getValuesAsRows(java.util.List<java.util.List<?>> values,
                                                                                                         java.util.List<java.lang.String> columns)

    - #### getValuesAsMatrix

          public static java.util.List<java.util.List<?>> getValuesAsMatrix(java.util.List<java.util.List<?>> values)

    - #### getValuesAsDictionary

          public static java.util.Map<java.lang.String,java.lang.Object> getValuesAsDictionary(java.util.List<java.util.List<?>> values)

    - #### getValuesAsRows

          public java.util.List<java.util.Map<java.lang.String,java.lang.Object>> getValuesAsRows()

    - #### getValuesAsMatrix

          public java.util.List<java.util.List<?>> getValuesAsMatrix()

    - #### getValuesAsDictionary

          public java.util.Map<java.lang.String,java.lang.Object> getValuesAsDictionary()

    - #### getValues

          public java.util.List<java.util.List<?>> getValues()

    - #### getColumnNames

          public java.util.List<java.lang.String> getColumnNames()

    - #### getTypes

          public java.util.List<java.lang.String> getTypes()

    - #### getSubtype

          public java.lang.String getSubtype()

    - #### setDoubleClickAction

          public void setDoubleClickAction(java.lang.String tagName)

    - #### setDoubleClickAction

          public void setDoubleClickAction(java.lang.Object listener)

    - #### fireDoubleClick

          public void fireDoubleClick(java.util.List<java.lang.Object> params,
                                      com.twosigma.beakerx.message.Message message)

    - #### fireContextMenuClick

          public void fireContextMenuClick(java.lang.String name,
                                           java.util.List<java.lang.Object> params,
                                           com.twosigma.beakerx.message.Message message)

    - #### getDoubleClickTag

          public java.lang.String getDoubleClickTag()

    - #### hasDoubleClickAction

          public boolean hasDoubleClickAction()

    - #### addContextMenuItem

          public void addContextMenuItem(java.lang.String name,
                                         java.lang.Object closure)

    - #### addContextMenuItem

          public void addContextMenuItem(java.lang.String name,
                                         java.lang.String tagName)

    - #### getContextMenuItems

          public java.util.Set<java.lang.String> getContextMenuItems()

    - #### getContextMenuTags

          public java.util.Map<java.lang.String,java.lang.String> getContextMenuTags()

    - #### setDetails

          public void setDetails(TableActionDetails details)

    - #### getDetails

          public TableActionDetails getDetails()

    - #### runClosure

          protected java.lang.Object runClosure(java.lang.Object closure,
                                                java.lang.Object... params)
                                         throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### serializeToJsonObject

          protected java.util.Map serializeToJsonObject()

      Specified by:
        `serializeToJsonObject` in class `com.twosigma.beakerx.widget.BeakerxWidget`

    - #### serializeToJsonObject

          protected java.util.Map serializeToJsonObject(java.lang.Object item)

      Specified by:
        `serializeToJsonObject` in class `com.twosigma.beakerx.widget.BeakerxWidget`

    - #### getRowLimitMsg

          public java.lang.String getRowLimitMsg()

    - #### updateCell

          public void updateCell(int row,
                                 java.lang.String columnName,
                                 java.lang.Object value)

    - #### setRowLimitMsg

          public void setRowLimitMsg(java.lang.String rowLimitMsg)